class SGF < EUCstr
   LineLength=60

   attr_reader  :errMsg
   attr_reader  :garvage

   def toGameTree
      ary=toSGFarray
      if ary==nil
         @errMsg = '<qt><h3>SGFʸˡ顼</h3>' + @errMsg
         @errMsg += '</qt>'
         return nil
      end

      tree=ary.toGameTree
      tree.analyze
      return tree
   end


   def toSGFarray
      ary=SGFarray.new

      n=0
      nGarvage=0
      sGarvage=''

      inSGF = false
      nKakko = 0
      inPropVal   = false
      escape      = false
      propName=''
      propVal =''
      buf=''
      nBuf=0
      lastElementIndex=-1

      self.gsub(/./me){|ch|
         n+=1
         if ! inSGF
            if ch=='('
               inSGF=true
               ary.push(ch)
               lastElementIndex=n-1
               nKakko=1
               if sGarvage!=''
                  sGarvage.sub!(/(\s+)\z/me,'')
                  if $1!=nil
                     nGarvage-=$1.size
                  end
               end
            else
               if sGarvage!='' || (ch=~/\s/e)==nil
                  nGarvage+=1
                  sGarvage<<ch
               end
            end
            next
         end

         if inPropVal
            if escape
               propVal<<ch if ch!="\n"
               escape=false
            else
               if ch==']'
                  if propName!=''
                     ary.push(propName)
                     propName=''
                  end
                  ary.push('[')
                  ary.push(propVal)
                  ary.push(']')
                  lastElementIndex=n-1
                  propVal =''
                  inPropVal  = false
               elsif ch=="\\"
                  escape=true
               else
                  propVal<<ch
               end
            end
            next
         end

         if nKakko==0
            if (ch=~/\s/e)==nil || buf!=''
               nBuf+=1
               buf<<ch
            end
            next
         end

         if ch==';' || ch=='(' || ch==')' 
            begin
               l=ary.last
               if ch==';' 
                  raise if !( l=='(' || l==';' || l==']' )
               elsif ch=='('
                  raise if !( l==';' || l==']' || l==')' )
               elsif  ch==')'
                  raise if !( l==';' || l==']' || l==')' )
               end
            rescue
               ii=lastElementIndex
               if l=='(' && ch!=';'
                   @errMsg='"("θ";"ޤ'
                   @errMsg += '<br><br><pre>' 
                   @errMsg += '<font color="#FF0000">'
                   @errMsg += '('+'</font>'
                   nn=ii+10
                   nn=n-1 if n-1>nn
                   @errMsg += self.substr(ii+1..nn)
                   @errMsg += '</pre>'
                   return nil
               end
               @errMsg='"'+ch+'"ΰ֤Ǥ<br><br>' 
               @errMsg += '<pre>'
               @errMsg += self.substr(ii..n-2)
               @errMsg += '<font color="#FF0000">'
               @errMsg += ch+'</font>'
               @errMsg += self.substr(n..n+10)
               @errMsg += '</pre>'
               return nil
            end
            ary.push(ch)
            lastElementIndex=n-1
            nKakko+=1 if ch=='('
            nKakko-=1 if ch==')'
            if buf!=''
               buf.sub!(/(\s+)\z/me,'')
               if $1!=nil
                  nBuf-=$1.size
               end
               sGarvage+="\n"+buf
               nGarvage+=nBuf
               buf=''
               nBuf=0
            end
         elsif ch=='['
            l=ary.last
            if !(l==']' || l==';')
               nBuf+=1
               buf<<ch
               next
            end

            if buf.sub!(/\A[A-Z]+\z/me,'')
               propName=$&
               inPropVal=true                
               nBuf=0
            elsif buf.empty?
               if l==']' 
                  inPropVal=true
               else
                  buf<<ch
                  nBuf+=1
               end
            else
               if buf.sub!(/(\s*)([A-Z]+)(\s*)\z/me,'')
                  propName=$2
                  inPropVal=true
                  nBuf -= $1.size+$2.size+$3.size
                  if ! buf.empty?
                     sGarvage+="\n"+buf
                     nGarvage+=nBuf
                     buf=''
                     nBuf=0
                  end
               else
                  buf<<ch
                  nBuf+=1
               end
            end
         else
            if (ch=~/\s/e)==nil || buf!=''
               nBuf+=1
               buf<<ch
            end
         end
      }

      if inPropVal
         s = '"["ĤƤޤ'+"\n\n" 
         s += '['+propVal
         @errMsg=s
         return nil
      end
      if nKakko!=0
         s = '̤ޤ'
         @errMsg=s
         return nil
      end

      if buf!=''
         buf.sub!(/(\s+)\z/me,'')
         sGarvage+="\n"+buf
      end
      if nGarvage>20 && nGarvage>n*0.3
         @errMsg='SGFǡǤϤʤ褦Ǥ'
         return nil
      end

      @garvage=nil
      if sGarvage!=''
         @garvage="ʸ̵뤷ޤ\n\n"
         @garvage+=sGarvage
      end
      return ary
   end
end

class SGFarray < Array
   def toGameTree
      tree=GameTree.new
      iTree=-1
      parentStack=Array.new
      iParent=nil
      propID=nil
      propVal=nil
      i=1
      while i<length
         if self[i]==';'
            iTree+=1
            tree[iTree]=Node.new
            tree[iTree].parent=iParent
            if iParent!=nil
               tree[iParent].addChild(iTree)
            end
            iParent=iTree
         elsif self[i]=='('
            parentStack.push(iParent)
         elsif self[i]==')'
            iParent=parentStack.pop
            if iParent==nil
               break#  end
            end
         elsif self[i]=~/^[A-Z]+/
            propID=self[i]
            propVal=PropValue.new
            while self[i+1]=='['
               propVal.push(self[i+2])
               i+=3
            end
            a=tree[iTree].addProp(propID,propVal)
         end
         i+=1
      end
      return tree
   end
end
